#include <array>
#include <iostream>
#include <vector>
#include <deque>
#include <string>
#include <functional>
#include <iterator> // e.g. ostream_iterator
#include <algorithm> // e.g. unique

#include "dosFarben.h"
using namespace std;


template <typename Iter, typename Str>
void PrintTo(ostream& str, Iter beg, Iter end, Str astr)
{
   str << astr;
   copy(beg, end, ostream_iterator<int>(str, ";"));
}


void PrintBeforeUniqueAfterVector(vector<int>& cont)
{
   PrintTo(cout, cont.begin(), cont.end(), "Mit vector: before: ");
   auto newEnd = cont.end();
   // auto newEnd = Aufruf von unique um Dubletten aus cont zu entfernen
   cout << endl;
   PrintTo(cout, cont.begin(), newEnd, "after:  ");
   cout << endl;
}

void PrintBeforeUniqueAfterDeque(deque<int>& cont)
{
   PrintTo(cout, cont.begin(), cont.end(), "Mit deque: before: ");
   auto newEnd = cont.end();
// auto newEnd = Aufruf von unique um Dubletten aus cont zu entfernen
   cout << endl;
   PrintTo(cout, cont.begin(), newEnd, "after:  ");
   cout << endl;
}

void PrintBeforeUniqueAfterArray(array<int, 7>& cont)
{
   PrintTo(cout, cont.begin(), cont.end(), "Mit array: before: ");
   auto newEnd = cont.end();
   // auto newEnd = Aufruf von unique um Dubletten aus cont zu entfernen
   cout << endl;
   PrintTo(cout, cont.begin(), newEnd, "after:  ");
   cout << endl;
}




void aufgabe1()
{
   printScreenColorOnceVal(cout, RED_SCREEN_COLOR, 
      "Aufgabe 1  noch nicht fertig:\n");
   deque<int> dequeInt = { 1, 3, 3, 3, 5, 5, 7 };
   PrintBeforeUniqueAfterDeque(dequeInt);

   array<int,7> arr = { 1, 3, 3, 3, 5, 5, 7 };
   PrintBeforeUniqueAfterArray(arr);

   vector<int> vec = { 1, 3, 3, 3, 5, 5, 7 };
   PrintBeforeUniqueAfterVector(vec);
}



